Index: code/branches/bugger/src/orxonox/objects/worldentities/PositionableEntity.cc
===================================================================
--- code/branches/bugger/src/orxonox/objects/worldentities/PositionableEntity.cc	(revision 2530)
+++ code/branches/bugger/src/orxonox/objects/worldentities/PositionableEntity.cc	(revision 2531)
@@ -48,12 +48,12 @@
     void PositionableEntity::registerVariables()
     {
-        REGISTERDATA(this->getPosition().x, direction::toclient);
-        REGISTERDATA(this->getPosition().y, direction::toclient);
-        REGISTERDATA(this->getPosition().z, direction::toclient);
+        registerVariable(this->getPosition().x, variableDirection::toclient);
+        registerVariable(this->getPosition().y, variableDirection::toclient);
+        registerVariable(this->getPosition().z, variableDirection::toclient);
 
-        REGISTERDATA(this->getOrientation().w, direction::toclient);
-        REGISTERDATA(this->getOrientation().x, direction::toclient);
-        REGISTERDATA(this->getOrientation().y, direction::toclient);
-        REGISTERDATA(this->getOrientation().z, direction::toclient);
+        registerVariable(this->getOrientation().w, variableDirection::toclient);
+        registerVariable(this->getOrientation().x, variableDirection::toclient);
+        registerVariable(this->getOrientation().y, variableDirection::toclient);
+        registerVariable(this->getOrientation().z, variableDirection::toclient);
     }
 }
Index: code/branches/bugger/src/orxonox/objects/worldentities/WorldEntity.cc
===================================================================
--- code/branches/bugger/src/orxonox/objects/worldentities/WorldEntity.cc	(revision 2530)
+++ code/branches/bugger/src/orxonox/objects/worldentities/WorldEntity.cc	(revision 2531)
@@ -105,14 +105,14 @@
     void WorldEntity::registerVariables()
     {
-        REGISTERSTRING(this->mainStateName_, direction::toclient, new NetworkCallback<WorldEntity>(this, &WorldEntity::changedMainState));
+        registerVariable(this->mainStateName_, variableDirection::toclient, new NetworkCallback<WorldEntity>(this, &WorldEntity::changedMainState));
 
-        REGISTERDATA(this->bActive_,  direction::toclient, new NetworkCallback<WorldEntity>(this, &WorldEntity::changedActivity));
-        REGISTERDATA(this->bVisible_, direction::toclient, new NetworkCallback<WorldEntity>(this, &WorldEntity::changedVisibility));
-
-        REGISTERDATA(this->getScale3D().x, direction::toclient);
-        REGISTERDATA(this->getScale3D().y, direction::toclient);
-        REGISTERDATA(this->getScale3D().z, direction::toclient);
-
-        REGISTERDATA(this->parentID_, direction::toclient, new NetworkCallback<WorldEntity>(this, &WorldEntity::updateParent));
+        registerVariable(this->bActive_,  variableDirection::toclient, new NetworkCallback<WorldEntity>(this, &WorldEntity::changedActivity));
+        registerVariable(this->bVisible_, variableDirection::toclient, new NetworkCallback<WorldEntity>(this, &WorldEntity::changedVisibility));
+  
+        registerVariable(this->getScale3D().x, variableDirection::toclient);
+        registerVariable(this->getScale3D().y, variableDirection::toclient);
+        registerVariable(this->getScale3D().z, variableDirection::toclient);
+  
+        registerVariable(this->parentID_, variableDirection::toclient, new NetworkCallback<WorldEntity>(this, &WorldEntity::updateParent));
     }
 
Index: code/branches/bugger/src/orxonox/objects/worldentities/WorldEntity.h
===================================================================
--- code/branches/bugger/src/orxonox/objects/worldentities/WorldEntity.h	(revision 2530)
+++ code/branches/bugger/src/orxonox/objects/worldentities/WorldEntity.h	(revision 2531)
@@ -36,5 +36,5 @@
 #include <OgreSceneNode.h>
 
-#include "network/Synchronisable.h"
+#include "network/synchronisable/Synchronisable.h"
 #include "core/BaseObject.h"
 #include "util/Math.h"
Index: code/branches/bugger/src/orxonox/objects/worldentities/pawns/Pawn.cc
===================================================================
--- code/branches/bugger/src/orxonox/objects/worldentities/pawns/Pawn.cc	(revision 2530)
+++ code/branches/bugger/src/orxonox/objects/worldentities/pawns/Pawn.cc	(revision 2531)
@@ -99,7 +99,7 @@
     void Pawn::registerVariables()
     {
-        REGISTERDATA(this->bAlive_, direction::toclient);
-        REGISTERDATA(this->health_, direction::toclient);
-        REGISTERDATA(this->initialHealth_, direction::toclient);
+        registerVariable(this->bAlive_, variableDirection::toclient);
+        registerVariable(this->health_, variableDirection::toclient);
+        registerVariable(this->initialHealth_, variableDirection::toclient);
     }
 
Index: code/branches/bugger/src/orxonox/objects/worldentities/pawns/SpaceShip.cc
===================================================================
--- code/branches/bugger/src/orxonox/objects/worldentities/pawns/SpaceShip.cc	(revision 2530)
+++ code/branches/bugger/src/orxonox/objects/worldentities/pawns/SpaceShip.cc	(revision 2531)
@@ -85,7 +85,7 @@
     void SpaceShip::registerVariables()
     {
-        REGISTERDATA(this->maxRotation_,             direction::toclient);
-        REGISTERDATA(this->rotationAcceleration_,    direction::toclient);
-        REGISTERDATA(this->translationDamping_,      direction::toclient);
+        registerVariable(this->maxRotation_,             variableDirection::toclient);
+        registerVariable(this->rotationAcceleration_,    variableDirection::toclient);
+        registerVariable(this->translationDamping_,      variableDirection::toclient);
     }
 
Index: code/branches/bugger/src/orxonox/objects/worldentities/pawns/Spectator.cc
===================================================================
--- code/branches/bugger/src/orxonox/objects/worldentities/pawns/Spectator.cc	(revision 2530)
+++ code/branches/bugger/src/orxonox/objects/worldentities/pawns/Spectator.cc	(revision 2531)
@@ -91,6 +91,6 @@
     void Spectator::registerVariables()
     {
-        REGISTERDATA(this->bGreetingFlareVisible_, direction::toclient, new NetworkCallback<Spectator>(this, &Spectator::changedFlareVisibility));
-        REGISTERDATA(this->bGreeting_,             direction::toserver, new NetworkCallback<Spectator>(this, &Spectator::changedGreeting));
+        registerVariable(this->bGreetingFlareVisible_, variableDirection::toclient, new NetworkCallback<Spectator>(this, &Spectator::changedFlareVisibility));
+        registerVariable(this->bGreeting_,             variableDirection::toserver, new NetworkCallback<Spectator>(this, &Spectator::changedGreeting));
     }
 
Index: code/branches/bugger/src/util/mbool.h
===================================================================
--- code/branches/bugger/src/util/mbool.h	(revision 2530)
+++ code/branches/bugger/src/util/mbool.h	(revision 2531)
@@ -36,4 +36,5 @@
     struct _UtilExport mbool
     {
+//        friend Synchronisable::registerVariable<>()
         public:
             inline mbool(bool value = false)
@@ -67,4 +68,6 @@
             inline bool operator!() const
                 { return (!this->value_.bool_); }
+            
+            inline unsigned char& getMemory(){ return value_.memory_; }
 
         private:
Index: code/branches/bugger/visual_studio/vc8/network.vcproj
===================================================================
--- code/branches/bugger/visual_studio/vc8/network.vcproj	(revision 2530)
+++ code/branches/bugger/visual_studio/vc8/network.vcproj	(revision 2531)
@@ -197,5 +197,5 @@
 			</File>
 			<File
-				RelativePath="..\..\src\network\Synchronisable.cc"
+				RelativePath="..\..\src\network\TrafficControl.cc"
 				>
 			</File>
@@ -229,4 +229,24 @@
 				<File
 					RelativePath="..\..\src\network\packet\Welcome.cc"
+					>
+				</File>
+			</Filter>
+			<Filter
+				Name="synchronisable"
+				>
+				<File
+					RelativePath="..\..\src\network\synchronisable\NetworkCallbackManager.cc"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\network\synchronisable\Synchronisable.cc"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\network\synchronisable\SynchronisableSpecialisations.cc"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\network\synchronisable\SynchronisableVariable.cc"
 					>
 				</File>
@@ -279,8 +299,4 @@
 			</File>
 			<File
-				RelativePath="..\..\src\network\NetworkCallback.h"
-				>
-			</File>
-			<File
 				RelativePath="..\..\src\network\NetworkPrereqs.h"
 				>
@@ -292,8 +308,4 @@
 			<File
 				RelativePath="..\..\src\network\Server.h"
-				>
-			</File>
-			<File
-				RelativePath="..\..\src\network\Synchronisable.h"
 				>
 			</File>
@@ -327,4 +339,24 @@
 				<File
 					RelativePath="..\..\src\network\packet\Welcome.h"
+					>
+				</File>
+			</Filter>
+			<Filter
+				Name="synchronisable"
+				>
+				<File
+					RelativePath="..\..\src\network\synchronisable\NetworkCallback.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\network\synchronisable\NetworkCallbackManager.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\network\synchronisable\Synchronisable.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\network\synchronisable\SynchronisableVariable.h"
 					>
 				</File>
